#ifndef GAME_H
#define GAME_H

#include <cpctelera.h>
#include "Dialog.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Hud.h"
#include "Inventory.h"
#include "Palette.h"
#include "Keys.h"
#include "Map.h"

//any initialisation that needs to occur before the game can start
void initGame(u8 level, u8 x, u8 y, u8 xScroll, u8 yScroll);

//runs the game and the gameloop
void runGame();

//this is where the processing of all the game logic happens
void gameLogic();

//read input from the player/user
void readInput();

//displays the contents of the game on the screen as it changes
void drawGame();

// Setups up and runs the game.
void runGameSession();

// Chose the next level from the entrance cave based on position of the entrance.
u8 chooseNextCave(u8 x, u8 y);

// Updates entrance caves to completed graphic based on caveComplete[].
void updateCompleteEntranceCaves();

#endif