#ifndef GAMETYPES_H
#define GAMETYPES_H

#include <types.h>

#define TRUE 1
#define FALSE 0

#ifndef WINCPCTELERA
#define NULL 0
#endif

#define SCREEN_X 80
#define SCREEN_Y 200
#define SCREEN_Y_NO_HUD 192

#define MAP_CELL_COUNT 2160

// Maximum number of enemies that can be loaded from a map.
#define MAX_ENEMY_ELEMENT_COUNT 492

#define ASCII_TO_NUMBER_OFFSET 48

// TODO fix placeholder value
#define LEVEL_COUNT 12

#define GAME_COMPLETE 15

#define TILE_HEIGHT 16
#define TILE_WIDTH_BYTES 4
#define SCREEN_TILES_Y 12
#define SCREEN_TILES_X 20

#define MAP_TILES_Y 36
#define MAP_TILES_X 60

#define DIRECTION_COUNT 4
#define DIRECTION_LEFT 1
#define DIRECTION_UP 2
#define DIRECTION_RIGHT 3
#define DIRECTION_DOWN 4

// TODO fix to remove suffix that shouldn't be here.

// Enemy traveling in the rightward direction.
#define ENEMY_DIRECTION_RIGHT_ 0

// Enemy traveling in the downward direction.
#define ENEMY_DIRECTION_DOWN_ 1

// Enemy traveling in the leftward direction.
#define ENEMY_DIRECTION_LEFT_ 2

// Enemy traveling in the upward direction.
#define ENEMY_DIRECTION_UP_ 3

// Turn states.
// The player's turn is now active.
#define PLAYER_TURN 0

// The projectile's turn is now active.
#define PROJECTILE_TURN 1

// All the enemies turns are active and will be run in sequence.
#define ENEMY_TURN 2

// The boss' turn is now active.
#define BOSS_TURN 3

// The possible bits that the cell graphic could be in.
#define CELL_GFX_RANGE 0x1F

// Values less than this are considered light blockers.
#define CELL_LIGHT_BLOCKER_GFX_RANGE 8

// Cell type flags.
#define CELL_ITEM_FLAG 0x20
#define CELL_INTERACTABLE_FLAG 0x40
#define CELL_LIGHT_FLAG 0x80
#define CELL_INTERACTABLE_OR_ITEM_FLAG 0x60

// Attack types
#define MELEE_ATTACK 0
#define RANGED_ATTACK 1

// Number of moves the player is allowed to move in the dark.
// TODO set to more appropriate value, currently high test value.
#define MAX_DARK_MOVE_COUNT 25

// Level states.
#define LEVEL_READY 0
#define LEVEL_END_COMPLETE 1
#define LEVEL_END_DEATH 2
#define LEVEL_END_EXIT 3

extern const u8 xPositions[20];
extern const u8 yPositions[12];

#endif