#ifndef MENU_H
#define MENU_H

#include "Game.h"
#include "GameState.h"
#include "Keys.h"
#include "Palette.h"
#include "Text.h"
#include "sprites/ItemSprites.h"

//sets up the main menu and runs the menu loop
void runMenu();

//draws the game main menu on screen
void drawMenu();

//displays a box next to the currently selected menu item
void drawIndicator();

//let the user choose new keyboard/joystick controls for the game
void rebindControls();

//get key function for rebind/redefine key controls by ranaldo
cpct_keyID getKey();

//switch between a GT64 friendly palette and normal colourful palette
void chooseGraphicMode();

//initialise high score values
void initScores();

//display current high scores on the screen
void displayHighScores();

//update the high scores if the player has a high score
void updateHighScores();

//displays either victorious or game over depending on if the user completes the game or not
void displayEndScreen();

// Choose the level of difficulty for the game session.
void chooseDifficulty();

#endif