#include "Palette.h"

u8 greenMode = 0;

// Normal levels.
const u8 standardPalette_[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x7, 0x12, 0xe, 0x1e, 0x4, 0x19 };

const u8 standardPalette_green_[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x12, 0x12, 0xe, 0x1e, 0x4, 0x19 };

// Menu palette so that background remains black with white text.
const u8 menuPalette_[16] = { 0x14, 0xa, 0x13, 0xc, 0x14, 0xb, 0x15, 0x0, 0x16, 0x1c, 0x7, 0x12, 0xe, 0x1e, 0x4, 0x19 };

// Plant based levels.
const u8 grassPalette_[16] = { 0x19, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x7, 0x12, 0xe, 0x1e, 0x4, 0x19 };

// Impassable terrain level and GT64 green grass.
const u8 impassablePalette_[16] = { 0x7, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x7, 0x12, 0xe, 0x1e, 0x4, 0x19 };

// Palettes for animating water.
const u8 waterPalette_0[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x1f, 0x7, 0x13, 0x1f, 0x15, 0x15 };
const u8 waterPalette_1[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x1f, 0x7, 0x15, 0x13, 0x15, 0x15 };
const u8 waterPalette_2[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x1f, 0x7, 0x15, 0x1f, 0x13, 0x15 };
const u8 waterPalette_3[16] = { 0x1f, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x0, 0x16, 0x1c, 0x1f, 0x7, 0x15, 0x1f, 0x15, 0x13 };

u8* const waterPalettes[4] = {waterPalette_0, waterPalette_1, waterPalette_2, waterPalette_3};

void choosePalette(u8 palette)
{
	if (greenMode)
	{
		if (palette == GRASS_PALETTE || palette == IMPASSABLE_PALETTE)
		{
			// Impassable looks much better than impassable in green.
			cpct_setPalette(impassablePalette_, 16);
		}
		else if (palette == STANDARD_PALETTE)
		{
			cpct_setPalette(standardPalette_green_, 16);
		}
	}
	else
	{
		if (palette == STANDARD_PALETTE)
		{
			cpct_setPalette(standardPalette_, 16);
		}
		else if (palette == GRASS_PALETTE)
		{
			cpct_setPalette(grassPalette_, 16);
		}
		else if (palette == IMPASSABLE_PALETTE)
		{
			cpct_setPalette(impassablePalette_, 16);
		}
	}

	if (palette == MENU_PALETTE)
	{
		cpct_setPalette(menuPalette_, 16);
	}
}