#include "Utility.h"

u8 highestBit(u8 value)
{
	u8 bit = 1;

	if (value == 0)
	{
		return 0;
	}

	while (value >>= 1)
	{
		bit <<= 1;
	}

	return bit;
}

u8 lowestBit(u8 value)
{
	u8 bit = 1;

	if (value == 0)
	{
		return 0;
	}

	while (!(value & bit))
	{
		bit <<= 1;
	}

	return bit;
}

i8 difference(u8 a, u8 b)
{
	if (a > b)
	{
		return b - a;
	}
	else if (b > a)
	{
		return a - b;
	}
	else
	{
		return 0;
	}
}

u8 bitCount(u8 value)
{
	u8 count = 0;

	while (value > 0)
	{
		if (value & 1)
		{
			++count;
		}

		value >>= 1;
	}
	
	return count;
}

u16 distance(u8 x, u8 y)
{
	return x * x + y * y;
}

u16 absoluteValue(i16 value)
{
	if (value < 0)
	{
		return value * -1;
	}
	else
	{
		return value;
	}
}