#ifndef UTILITY_H
#define UTILITY_H

#include <types.h>

u8 highestBit(u8 value);

u8 lowestBit(u8 value);

// Determine the difference between two u8 values.
i8 difference(u8 a, u8 b);

// Counts the number of bits set in a u8 value.
u8 bitCount(u8 value);

// For computing a euclidean distance approximation for comparison.
u16 distance(u8 x, u8 y);

// Compute the absolete value for a given signed value.
u16 absoluteValue(i16 value);

#endif